<?php

namespace Manager;

use Model\Coach;
use Model\Role;
use Model\User;
use Network\IAuthService;
use Stub\AuthService;

class CoachManager
{
    private IAuthService $authService;
    public ?User $currentUser = null; // Initialisé à null
    function __construct(IAuthService $authService)
    {
        $this->authService = $authService;

        // Assurez-vous que authService n'est pas null avant d'accéder à currentUser
        if ($this->authService && $this->authService->currentUser) {
            $this->currentUser = $this->authService->currentUser;
        }
    }

    public function getRole(): ?Role
    {
        // Assurez-vous que currentUser n'est pas null avant d'accéder à getRole()
        if ($this->currentUser && $this->currentUser->getRole()) {
            return $this->currentUser->getRole();
        }

        return null;
    }

    public function getUsersList(): ?Role
    {
        // Assurez-vous que currentUser n'est pas null avant d'accéder à getRole()
        if ($this->currentUser && $this->currentUser->getRole()->getUsersList()) {
            return $this->currentUser->getRole();
        }

        return null;
    }

// faire validation !!!
    public function addUser(User $user): void
    {
        // Assurez-vous que currentUser n'est pas null avant d'accéder à getRole()
        if ($this->currentUser && $this->currentUser->getRole()) {
            $this->currentUser->getRole()->addUser($user);
        } elseif($this->currentUser && !$this->currentUser->getRole()) {
            echo "Impossible d'ajouter l'utilisateur. role est null.";
        } elseif(!$this->currentUser) {
            echo "Impossible d'ajouter l'utilisateur. currentUser est null.";
        } else {
            echo "gros probleme !";
        }
    }

}

?>