<?php
namespace Stub;
use Model\Coach;
use Model\Athlete;

use Model\CoachAthlete;
use Model\User;
use Shared\Exception\NotImplementedException;
use Network\IAuthService;
use Shared\IHashPassword;
use Stub\UserRepository;
class AuthService implements IAuthService {
    private $userRepository;
    private $passwordHasher;

    public $currentUser;

    public function __construct(UserRepository $userRepository, IHashPassword $passwordHasher) {
        $this->userRepository = $userRepository;
        $this->passwordHasher = $passwordHasher;
    }

    public function login(string $username,string $password): ?User {
        $this->currentUser = $this->userRepository->GetItemByName($username,0,1);

        if($this->currentUser == null || !$this->currentUser instanceof User) {
            throw new \Exception('Unable to find user with that name');
        }
        if($this->currentUser->isValidPassword($password)) {
            return $this->currentUser;
        }
        return null;
    }
    public function register(string $loginUser, string $password, $data): bool
    {
    
        $hashedPassword = $this->passwordHasher->hashPassword($password);
    
        $existingUser = $this->userRepository->getItemByEmail($loginUser);
        
        if ($existingUser != null || $existingUser instanceof User ) {
            throw new \Exception('User already exists');
        }

        $username = $data['username'];
        $prenom = $data['prenom'];
        $nom = $data['nom'];
        $email = $data['email'];
        $sexe = $data['sexe'];
        $taille = $data['taille'];
        $poids = $data['poids'];
        $dateNaissance = $data['dateNaissance'] ;
        $roleName = $data['roleName'];
        $role = null;
        if($roleName == "Coach"){
            $role = new CoachAthlete();
        }
        else if($roleName == "Athlete"){
            $role = new Athlete();
        }
            $user = new User(
                random_int(0, 100),
                $username,
                $nom,
                $prenom,
                $email,
                $hashedPassword,
                $sexe,
                $taille,
                $poids,
                $dateNaissance,
                //should use reflexion
                $role
            );
        
        $this->userRepository->addItem($user);
    
        return true;
    }
    

    public function logoutUser(): void
    {
        if ($this->currentUser) {
            $this->currentUser = null; // Déconnexion en assignant null à currentUser
            echo "Déconnexion réussie.\n";
        } else {
            echo "Aucun utilisateur connecté.\n";
        }
    }
}